"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const log_1 = require("../common/log");
const util_1 = require("../common/util");
const child_process_1 = require("child_process");
exports.command = "test";
exports.desc = "测试项目";
exports.builder = (yargs) => {
    return yargs
        .option("p", {
        alias: "path",
        describe: "测试的目录",
        default: ".",
        type: "string"
    })
        .usage("Usage: $0 test -p .");
};
exports.handler = (yargs) => __awaiter(this, void 0, void 0, function* () {
    log_1.printMessage("测试开始...");
    let projectPath = path.resolve(yargs.p) || process.cwd();
    let nyc = util_1.getCreateProjectDependencies(projectPath, path.join("nyc", "bin", "nyc.js"));
    let mocha = util_1.getCreateProjectDependencies(projectPath, path.join("mocha", "bin", "mocha"));
    try {
        yield new Promise((resolve, reject) => {
            child_process_1.execFile(nyc, [mocha, "-t", "5000"], { cwd: projectPath, encoding: "utf-8" }, (err, stdout, stderr) => {
                if (err) {
                    console.log(stdout);
                    reject(stdout);
                }
                else {
                    console.log(stdout);
                    resolve(stdout);
                }
            });
        });
        return 0;
    }
    catch (e) {
        return 1;
    }
});
//# sourceMappingURL=test.js.map